#include <vector>
#include <fstream>
#include <queue>
#include <cstdio>

using namespace std;

int main()
{
	ifstream cin("war.in");
	ofstream cout("war.out");
	int n, m, t;
	cin >> n >> m >> t;
	vector<int> k(n);
	for (int i = 0; i < n; i++)
		cin >> k[i];

	vector<vector<int> > g(n);
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b, a--, b--;
		g[a].push_back(b), g[b].push_back(a);
	}
	int st, cnt_def;
	cin >> st >> cnt_def;
	vector<int> d(n, -1);
	d[st] = 0;
	queue<int> q;
	q.push(st);
	while (!q.empty())
	{
		int v = q.front(); 
		q.pop();
		for (size_t i = 0; i < g[v].size(); i++)
			if (d[g[v][i]] == -1)
			{
				d[g[v][i]] = d[v] + 1;
				q.push(g[v][i]); 
			}
	}

	vector<int> day(n);
	for (int i = 0; i < n; i++)
		if (d[i] != -1)	day[d[i]] += k[i];
	int cnt_att = 0;
	for (int i = 0; i < n; i++)
	{
		cnt_att += day[i];
		int kill = min(t, min(cnt_att, cnt_def));
		cnt_att -= kill, cnt_def -= kill;
		if (cnt_def == 0)
		{
			cout << "Vampires win\n";
			return 0;
		}
		if (cnt_att == 0)
		{
			cout << "Werewolves win\n";
			return 0;
		}
	}
	cout << ((cnt_att > cnt_def) ? "Werewolves win\n" : "Vampires win\n");
}
